%/*******************************************************************
%*
%*  DESCRIPTION:  building WireWorld model using CD++, 
%*
%*  AUTHOR: Abdulelah Alsanad
%*
%*  EMAIL: aalsa079@site.uottawa.ca
%*
%*  DATE: 09/11/2005
%*
%*******************************************************************/

[top]
components : wireworld

[wireworld]
type : cell
width : 20
height : 20
delay : transport
defaultDelayTime : 100
border : wrapped 
neighbors : wireworld(-1,-1) wireworld(-1,0) wireworld(-1,1) 
neighbors : wireworld(0,-1)  wireworld(0,0)  wireworld(0,1)
neighbors : wireworld(1,-1)  wireworld(1,0)  wireworld(1,1)
initialvalue : 0
initialCellsValue : OR.val	% The file that has the input values for the model to show different example	
localtransition : wireworld-rule


[wireworld-rule]
rule : 0 100 { (0,0) = 0 }  % a background cell always stays background 
rule : 2 100 { (0,0) = 1 }  % an electron head always becomes an electron tail 
rule : 3 100 { (0,0) = 2 }  % an electron tail always becomes a wire	
	% wire stays as wire unless it has just one or two neighbours that are electron heads, in which case it becomes an electron head  		
rule : 1 100 { (0,0) = 3 and (statecount(1) = 1 or statecount(1) = 2)} 
rule : 3 100 { t } 